﻿local MB = MacroBox
local _G = _G
local L = MB.L
local select, string, tonumber, format = select, string, tonumber, format
local GetSpellInfo, GetItemInfo = GetSpellInfo, GetItemInfo

MB.defaults = {
	profile = {
		x = (UIParent:GetWidth() - 300) / 2,
		y = (UIParent:GetHeight() - 424) / 2,
		scale = UIParent:GetScale(),
		shorten = false,
		usemtscale = false,
	},
}

function MB:EventHandler(this, event, arg1, ...)
	if event == "ADDON_LOADED" then
		if arg1 == "MacroToolkit_MacroBox" then
			_G.SLASH_MACROBOX_CMD1 = format("%smb", MB.slash)
			_G.SLASH_MACROBOX_CMD2 = format("%smacrobox", MB.slash)
			_G.SLASH_MACROBOX_CMD3 = format("%smbox", MB.slash)
			SlashCmdList["MACROBOX_CMD"] = function() MacroBoxFrame:Show() end
			MB.db = MB.LS("AceDB-3.0"):New("MacroBoxDB", MB.defaults, "profile")
			if MacroToolkit then MB.MT = true end
			if not IsAddOnLoaded("Blizzard_MacroUI") then LoadAddOn("Blizzard_MacroUI") end
		elseif arg1 == "Blizzard_MacroUI" and not MacroToolkit then
			local mtbutton = CreateFrame("Button", "MacroBoxOpen", MacroFrame, "UIPanelButtonTemplate")
			mtbutton:SetText("MacroBox")
			mtbutton:SetSize(94, 22)
			mtbutton:SetPoint("LEFT", MacroDeleteButton, "RIGHT")
			mtbutton:SetScript("OnClick",
				function()
					HideUIPanel(MacroFrame)
					MacroBoxFrame:Show()
				end)
		end
	elseif event == "PLAYER_LOGIN" then
		MB:GenerateMacros()
		MB:CreateMBFrame()
		MB:CreateOptions()
		--local tm = 0
		--for c, m in pairs(MB.Macros) do tm = tm + #m end
		--print("total macros:", tm)
		if IsAddOnLoaded("ElvUI") then MB:LoadElvSkin() end
	end
end

function MB:DisplayMacros(category)
	print(category)
end

function MB:DecodeMacro(macro)
	local macrotext = macro
	local em
	for i = #MB.MacroCommands, 1, -1 do macrotext = string.gsub(macrotext, format("//%d+", i), MB.MacroCommands[i]) end
	local s = select(3, string.find(macrotext, "(::%d+)"))
	while s do
		local sid = tonumber(string.sub(s, 3))
		if sid > 1000000 then
			sid = sid - 1000000
			em = true
		else em = false end
		local spell = GetSpellInfo(sid) or _G.UNKNOWN
		macrotext = string.gsub(macrotext, s, format(" %s%s", em and "!" or "", spell))
		s = select(3, string.find(macrotext, "(::%d+)"))
	end
	local i = select(3, string.find(macrotext, "($%d+)"))
	while i do
		local iid = tonumber(string.sub(i, 2))
		local item = GetItemInfo(iid) or _G.UNKNOWN
		macrotext = string.gsub(macrotext, i, format(" %s", item))
		i = select(3, string.find(macrotext, "($%d+)"))
	end
	macrotext = string.gsub(macrotext, "&", "\n")
	return macrotext
end