﻿local _G = _G
local MB = MacroBox
MB.LS = LibStub
MB.L = MB.LS("AceLocale-3.0"):GetLocale("MacroBox")
MB.slash = string.sub(_G.SLASH_CAST1, 1, 1)
MB.MACRONUM = "|cff00bfff%s|r: %d/%d"
local L = MB.L
local select, GetSpellInfo, format = select, GetSpellInfo, format
MB.frame:RegisterEvent("ADDON_LOADED")
MB.frame:RegisterEvent("PLAYER_LOGIN")
MB.frame:SetScript("OnEvent", function(...) MB:EventHandler(...) end)
MB.textures = {
	["general"] = {"Interface\\GossipFrame\\BinderGossipIcon", 0, 1, 0, 1},
	["hunter"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0, 0.25, 0.25, 0.5},
	["raid"] = {"Interface\\TARGETINGFRAME\\UI-RaidTargetingIcons", 0.75, 1, 0.25, 0.5},
	["deathknight"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.25, 0.5, 0.5, 0.75},
	["druid"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.75, 1, 0, 0.25},
	["mage"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.25, 0.5, 0, 0.25},
	["monk"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.5, 0.75, 0.5, 0.75},
	["paladin"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0, 0.25, 0.5, 0.75},
	["priest"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.5, 0.75, 0.25, 0.5},
	["rogue"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.5, 0.75, 0, 0.25},
	["shaman"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.25, 0.5, 0.25, 0.5},
	["warrior"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0, 0.25, 0, 0.25},
	["warlock"] = {"Interface\\TARGETINGFRAME\\UI-CLASSES-CIRCLES", 0.75, 1, 0.25, 0.5},
}

MB.MacroCommands = {
	[1] = _G.SLASH_CANCELAURA1,
	[2] = _G.SLASH_DISMOUNT1,
	[3] = _G.SLASH_SCRIPT1,
	[4] = _G.SLASH_CAST1,
	[5] = _G.SLASH_PET_DEFENSIVE1,
	[6] = _G.SLASH_PET_PASSIVE1,
	[7] = _G.SLASH_PET_FOLLOW1,
	[8] = "#show",
	[9] = "#showtooltip",
	[10] = _G.SLASH_PET_ATTACK1,
	[11] = _G.SLASH_PET_ASSIST1,
	[12] = _G.SLASH_EMOTE3,
	[13] = _G.SLASH_STOPMACRO1,
	[14] = _G.SLASH_CLEARTARGET1,
	[15] = _G.SLASH_ASSIST2,
	[16] = _G.SLASH_TARGET_NEAREST_ENEMY1,
	[17] = _G.SLASH_STARTATTACK1,
	[18] = _G.SLASH_CLEARFOCUS1,
	[19] = _G.SLASH_FOCUS1,
	[20] = _G.SLASH_STOPCASTING1,
	[21] = _G.SLASH_RAID_WARNING1,
	[22] = _G.SLASH_PET_AGGRESSIVE1,
	[23] = _G.SLASH_TARGET_LAST_TARGET1,
	[24] = _G.SLASH_TARGET_NEAREST_ENEMY_PLAYER1,
	[25] = _G.SLASH_TARGET1,
	[26] = _G.SLASH_TARGET_NEAREST_FRIEND_PLAYER1,
	[27] = _G.SLASH_CLICK1,
	[28] = _G.SLASH_USE1,
}

--tokenised to make them locale agnostic
-- // - slash/# command, :: = spell id, $ = item id, & = newline
local function gsi(sid) return select(1, GetSpellInfo(sid)) end
-- ** 80 **
function MB:GenerateMacros()
	MB.Macros = {
	["general"] = {
		[1] = {"//1::19263&//1::1022&//1::44212&//1::54649&//1::1706&//1::130&//1::34477&//2&//3 VehicleExit()", L["Cancel auras"], 1},
		[2] = {"//9&//4 [mod:shift,nocombat]::116562&//13 [mod]&//14 [dead]&//16 [noexists]&//15 [help,nodead,combat]&//17 [harm,nodead]", L["Attack, or fish"], 2},
		[3] = {"//3 local a=\"gxWindow\";SetCVar(a,1-GetCVar(a));SetCVar(\"gxMaximize\",0);RestartGx()", L["Toggle screen mode"], 3},
		[4] = {"//3 SetCVar(\"cameraDistanceMax\",50)", L["Max camera distance"], 87},
	},
	["hunter"] = {
		[1] = {"//4$5512&//4 [@player,combat]::90361&//4 [@player,combat]::53480&//4 [combat]$76097&//4 [@player,nocombat]$82830", _G.SHOW_COMBAT_HEALING, 4},
		[2] = {"//5&//6&//7&//4::23145&//4::61684&//4::55709&//4 [@player]::126393", L["Pet rescue"], 5},
		[3] = {"//9::53271&//5&//6&//4 [@player]::53271&//4::23145&//4::61684", gsi(53271), 6},
		[4] = {"//4$76089&//4 [nocombat]::23145&//4 [nocombat]::61684&//4 [combat]13&//4 [combat]14&//4 [combat]::3045&//4 [combat]::121818&//4 [combat]::53401&//10&//11&//4 [combat]::90355", L["Finishing attack"], 7},
		[5] = {format("//9&//4::20736&//12 %s", format(L["casts %s on %s"], gsi(20736), "%T")), gsi(20736), 8},
		[6] = {"//9&//4 [@mouseover,help,nodead][@focus,help,nodead][]::34477", gsi(34477),9},
		[7] = {"//9&//19 [@target,noexists]&//4 [@focus, exists]::34477&//15 [@focus]&//10&//4 [@target,exists]::1130", format("%s 2", gsi(34477)), 10},
		[8] = {"//9::1543&//4::19885&//22&//4::1001543", L["Rogue finder"], 11},
		[9] = {"//9&//23&//4 [@target, exists][@mouseover,harm,dead]::125048", gsi(125048), 12},
		[10] = {"//9::781&//4::5116&//4::781&//4::5118", L["Run away!"], 13},
		[11] = {"//9&//4 [@mouseover,harm][]::1513", gsi(1513), 79},
		[12] = {"//9::130392&//10&//28 13&//28 14&//4::19574&//4::53401&//4::130392", gsi(130392), 80},
		[13] = {"//9&//4 [@focus]::34490", gsi(34490), 81},
	},
	["raid"] = {
		[1] = {format("//3 SetRaidTargetIcon(\"target\",7)&//21 %s&/dbm pull 3", L["Pulling in 3 seconds"]), L["Pull with DBM warning"], 14},
		[2] = {"//27 ExtraActionButton1", L["Click boss action button"], 15},
		[3] = {"//3 if(xx or 0)==0 then xx=9 end xx=xx-1 SetRaidTarget(\"mouseover\",xx)", _G.BINDING_HEADER_RAID_TARGET, 16},
		[4] = {"//19 [@mouseover,exists][exists]&//13 [@mouseover,exists][exists]&//18", L["Focus macro"], 97},
	},
	["deathknight"] = {
		[1] = {"//9&//4 [@mouseover,help][]::61999", gsi(61999), 17},
		[2] = {"//9&//4::1049039;&//4 [@player]::47541", _G.SHOW_COMBAT_HEALING, 18},
		[3] = {"//9&//4::56815&//4::45529", gsi(45529), 19},
		[4] = {"//9::48743&//4::46584&//4::48743", gsi(48743), 20},
		[5] = {"//8&//4 [mod:alt]::48265;[mod:shift]::48263;[nomod]::48266", L["Presences"], 77},
		[6] = {"//9&//4 [@mouseover,exists,help,nodead][]::108199", gsi(108199), 88},
		[7] = {format("//9&//4 [@mouseover,exists,nodead,harm][]::77606&//3 SendChatMessage(\"%s\",\"WHISPER\",nil,GetUnitName(\"mouseover\")or GetUnitName(\"target\",1))", format(L["%s on you!"], gsi(77606))), gsi(77606), 89},
		[8] = {"//9&//4::1043265", gsi(43265), 91},
		[9] = {"//9&//4::1051052", gsi(51052), 92},
		[10] = {"//9&//17&//4 [@mouseover,exists,help,nodead][]::47541", gsi(47541), 93},
		[11] = {"//9&//17&//4 [@mouseover,exists,nodead,harm][]::130736", gsi(130736), 94},
		[12] = {"//9::46584&//3 PetDismiss()&//4::46584", gsi(46584), 95},
		[13] = {"//9::111673&//3 PetDismiss()&//4::111673", gsi(111673), 96},
		[14] = {"//9&//4 [mod:ctrl,@pet][]::47541", format("%s 2", gsi(47541)), 98},
		[15] = {"//9::51271&//28 13&//28 14&//4::51271&//4::46584", gsi(51271), 99},
	},
	["druid"] = {
		[1] = {"//9&//4 [@mouseover,help,nodead][@focus,help,nodead][@target,help,nodead][@player]::29166", gsi(29166), 21},
		[2] = {"//9&//3 SetCVar(\"autoUnshift\",0)&//4::132158&//4::5185&//3 SetCVar(\"autoUnshift\",1)", gsi(132158), 22},
		[3] = {"//9&//4 [@mouseover,help,nodead][]::88423", gsi(88423), 23},
		[4] = {"//9&//4 [combat]::58984;[nocombat,noform:3]::768;[nocombat,form:3]::1005215", gsi(5215), 78},
		[5] = {"//9&//4 [@target,help][@targettarget,help]::774", gsi(774), 100},
		[6] = {format("//9&//4 [nocombat]::50769&//13 [nocombat]&//4::20484&//12 %s", format(L["casts %s on %s"], gsi(50769), "%T")), format("%s/%s", gsi(50769), gsi(20484)), 101},
		[7] = {"//9&//4 [form:3]::5487&//4 [form:1][]::768", format("%s/%s", gsi(5487), gsi(768)), 49},
		[8] = {format("//9::24858&//4 [form:5,swimming,nocombat]::1066;[form:5,flyable,nocombat]::40120;[form:5,nocombat] %s;[form:5,combat]::783;::24858", L["Mount name"]), gsi(24858), 46},
		[9] = {"//9&//4 [@focus,btn:2][@player]::88423", format("%s 2", gsi(88423)), 53},
		[10] = {"//9&//4 [@mouseover,dead,combat][dead,combat]::20484;[@mouseover,dead][dead]::50769", format("%s/%s 2", gsi(50769), gsi(20484)), 47},
		[11] = {"//9&//4 [@mouseover,exists,help,stance:0][@target,stance:0,help]::102401&//4 [stance:1/3,@mouseover,exists,harm][stance:1/3,@target,exists,harm]::102401&//4 [stance:2/5/4]::102401", gsi(102401), 48},
		[12] = {"//9&//4 [mod:ctrl,@mouseover]::94447;[@focus,nodead][@mouseover]::94447&//3 UIErrorsFrame:Clear()", gsi(94447), 51},
	},
	["mage"] = {
		[1] = {"//9&//20&//4 [@focus,exists][]::30449", gsi(30449), 24},
		[2] = {"//9&//20&//4::1953", gsi(1953), 25},
		[3] = {"//9&//4 [@mouseover,nodead,help][nodead,help][@player]::130", gsi(130), 26},
		[4] = {format("//9&//18 [mod:alt]&//19 [@focus,noexists]&//4 [@focus,exists][@target,exists]::118&//12 %s", format(L["casts %s on %s"], gsi(118), "%F")), gsi(118), 27},
		[5] = {"//9&//20&//4::45438&//1::45438", gsi(45438), 102},
		[6] = {"//9&//20&//4::2139", gsi(2139), 103},
		[7] = {"//9&//4 [@mouseover,exists][]::475", gsi(475), 104},
		[8] = {"//9&//4 [@mouseover,harm,nodead,exists]::125430", gsi(125430), 105},
	},
	["monk"] = {
		[1] = {"//9::123904&//28 13&//28 14&//4::115399&//4::116740&//4::123904", gsi(123904), 28},
		[2] = {"//9::115080&//4::115203&//4::115080", gsi(115080), 29},
		[3] = {"//9&//4 [dead, help][mod:shift]::115178;[mod:SELFCAST,@player][btn:2,@player]::115450", L["Dispel and res"], 30},
		[4] = {"//8::116705&//4 [form:1]::103985&//4 [form:2]::116705&//4 [form:2]::136336", gsi(116705), 90},
	},
	["paladin"] = {
		[1] = {"//9&//4 [@player][@focus,mod:shift,exists][@target,btn:2,exists]::4987", gsi(4987), 31},
		[2] = {"//9&//4 [@focus,exists]Repentance; [@mouseover,harm]::20066", gsi(20066), 32},
		[3] = {"//9&//4 [@mouseover,help][help][@player]::20925", gsi(20925), 106},
		[4] = {"//9&//4 [@mouseover,help][@target,help][@targettarget,exists,help][@player]::4987", format("%s 2", gsi(4987)), 107},
		[5] = {"//9&//4 [@mouseover,help][@target,help][@targettarget,help][@player]::1022", gsi(1022), 108},
		[6] = {"//9&//4 [mod,@mouseover,help][mod,help]::1038;[@mouseover,help][help]::6940", gsi(6940), 109},
		[7] = {"//9&//4 [@focus,exists,harm][@focustarget,exists,harm][]::96231", gsi(96231), 110},
	},
	["priest"] = {
		[1] = {"//9&//4 [@mouseover,help,nodead][]::73325", gsi(73325), 33},
		[2] = {"//9&//4 [@mouseover, help]::17;[help]::17;[@targettarget,help]::17", gsi(17), 34},
		[3] = {"//9&//4 [@focus,help,nodead,exists][@player,nomod][mod,@target][@target,btn:2]::2061", gsi(2061), 35},
		[4] = {"//9&//4 [nopet]::34433&//10 [harm][@targettarget,harm]", gsi(34433), 36},
		[5] = {"//9&//4 [@target,harm,exists]::528;[@target,help,exists]::527", format("%s/%s", gsi(528), gsi(527)), 37},
		[6] = {"//9&//4 [mod:alt,@player][mod:ctrl,@target][@focus,exists,nodead,noharm][]::47788", gsi(47788), 38},
		[7] = {"//9&//20&//4 [@focus,exists,harm,nodead][]::15487", gsi(15487), 82},
		[8] = {"//9&//4 [@mouseovertarget,harm][@mouseover,harm][@targettarget,harm][harm]::585", gsi(585), 111},
		[9] = {"//9&//4 [@mouseovertarget,help]::121135", gsi(121135), 112},
	},
	["rogue"] = {
		[1] = {"//9&//24 [nodead,exists]&//4 [form:1/3,harm,nodead]::6770", L["Sap nearest enemy player"], 39},
		[2] = {format("//9::32645&//4 [@focus,exists][@%s,help]::57934&//4::32645", L["Player name"]), gsi(32645), 40},
		[3] = {"//9&//4::20577&//4::1784", gsi(20577), 41},
		[4] = {"//9&//4 [nocombat]::1784;::1856", format("%s/%s", gsi(1784), gsi(1856)), 83},
		[5] = {"//9&//4 [help][@focus,help][@targettarget,help]::57934", gsi(57934), 113},
		[6] = {"//9&//17&//28 13&//28 14&//4::13750&//4::121471", gsi(121471), 114},
	},
	["shaman"] = {
		[1] = {"//9&//20&//4 [@focus,exists][]::57994", gsi(57994), 42},
		[2] = {"//9&//20&//4 [@focus,exists][]::370", gsi(370), 43},
		[3] = {format("//9&//18 [modifier:alt]&//19 [@focus,noexists]&//4 [@focus,exists][@target,exists]::51514&//12 %s", format(L["casts %s on %s"], gsi(51514), "%F")), gsi(51514), 44},
		[4] = {format("//9&//18 [modifier:alt]&//19 [@focus,noexists]&//4 [@focus,exists][@target,exists]::76780&//12 %s", format(L["casts %s on %s"], gsi(76780), "%F")), gsi(76780), 45},
		[5] = {"//9&//19 [harm,noexists][harm,mod:shift]&//4 [@focus,exists,harm]::33786", gsi(33786), 50},
		[6] = {"//9&//13 [form]&//4 [harm]::2908;[dead,combat]::20484;[dead][mod:shift]::50769;[mod:SELFCAST,@player][btn:2,@player][]::2782", L["Dispel and res"], 52},
		[7] = {"//9&//4 [nomod]::8056&//4 [mod:ctrl]::8050&//4 [mod:alt]::8042", format("%s/%s/%s", gsi(8056), gsi(8050), gsi(8042)), 54},
		[8] = {format("//9&//4::974&//3 local s,t,n=\"%s\",\"target\" if IsSpellInRange(s,t)then SendChatMessage(\"%s\",\"WHISPER\",nil,UnitName(t))end", gsi(974), format("%s on you!", gsi(974))), gsi(974), 55},
		[9] = {"//9::403&//4::16188&//4::403", gsi(403), 56},
		[10] = {"//9::421&//4::16188&//4::421", gsi(421), 57},
		[11] = {"//9::77472&//4::16188&//4::77472", gsi(77472), 58},

	},
	["warrior"] = {
		[1] = {"//9&//4::46924&//1::46924", gsi(46924), 59},
		[2] = {"//9&//4 [help]::3411;::100", format("%s/%s", gsi(3411), gsi(100)), 60},
		[3] = {"//9::114192&//14 [help]&//25::114192&//4::3411&//4::114192&//23 [help]", gsi(114192), 61},
		[4] = {"//9&//4 [mod:ctrl]::114203;[mod:shift]::114192;[nomod]::114207", L["Banners"], 62},
		[5] = {"//9&//4 [form:1]::2458&//4 [form:2]::2457&//4 [form:3]::71", _G.WHC_TITLE_WARRIOR_2, 63},
		[6] = {"//9&//4 [@focus,mod:shift,exists][@focus,btn:2,exists][@mouseover,mod:alt,exists][]::355", gsi(355), 64},
		[7] = {"//9&//4::97462&//4::118038&//4::1114203&//4::71", gsi(97462), 65},
		[8] = {"//9::100&//17&//4::1719&//28 13&//28 14&//4::100&//3 UIErrorsFrame:Clear()", gsi(100), 66},
		[9] = {"//9&//4 [@mouseover,exists][@focus,exists][@target,exists]::23922", gsi(23922), 67},
		[10] = {"//9&//4 [@target,help]::3411;&//13 [help]&//26&//4::3411&//23", gsi(3411), 68},
		[11] = {"//9::78&//4::85730&//4::78", gsi(78), 69},
		[12] = {"//9::1680&//4::12328&//4::1680", gsi(1680), 70},
		[13] = {"//9::55694&//4::18499&//4::55694", gsi(55694), 71},
	},
	["warlock"] = {
		[1] = {format("//9&//4 [@mouseover,exists][]::20707&//12 %s", format(L["casts %s on %s"], gsi(20707), "%T")), gsi(20707), 72},
		[2] = {format("//9&//18 [mod:alt]&//19 [@focus,noexists]&//4 [@focus,exists][@target,exists]::115268&//12 %s", format(L["casts %s on %s"], gsi(115268), "%F")), gsi(115268), 73},
		[3] = {"//9&//4::5484&//4::6789&//4::1030283", format("%s/%s/%s", gsi(5484), gsi(6789), gsi(30283)), 74},
		[4] = {"//9::116858&//28 13&//28 14&//4::77801&//4::116858", gsi(116858), 75},
		[5] = {"//9::103958&//4::77801&//4::103958", gsi(103958), 76},
		[6] = {"//9&//4::108359&//28$19008", gsi(108359), 84},
		[7] = {"//9::86121&//4::74434&//4::86121", gsi(86121), 85},
		[8] = {"//9&//4 [pet:imp,mod:shift,@player][pet:imp,@mouseover,exists]::89808&//4 [pet:fel imp]::115276&//4 [pet:succubus]::6358&//4 [pet:observer]::115782&//4 [pet:felhunter]::19647&//4 [pet:felguard]::89766&//4 [pet:voidwalker]::7812", L["All pet abilities"], 86},
	},
}
end
MB:GenerateMacros()